```
L    EEEE   A   RRR  NN   N     CCCC L    OOOOO GGGGG
L    E     A A  R  R N N  N     C    L    O   O G
L    EE   A   A RRR  N  N N     C    L    O   O G  GG
L    E    AAAAA R  R N   NN     C    L    O   O G   G
LLLL EEEE A   A R  R N    N     CCCC LLLL OOOOO GGGGG
```

COMMON-LISP "The Tutorial" Series (Google Doc Links)

* [Install Common-Lisp for MacOS](MACOS.md)
* [Install Common-Lisp for Win64](WINDOWS.md)
* [Install Common-Lisp for Linux](https://lisp-lang.org/learn/getting-started/)

The tutorial's goal is to get you writing real Lisp programs, quickly
(like in a day not weeks or years) and to give you the all important
high level summary of the entire language that will let you fill in
the many blanks and shortcuts with the solid books available, but
already being productive means having a bang up time doin' it all.


-  [01 - The Journey                      ](https://docs.google.com/document/d/1Mdp8IY7KzNxcThe9iZHXbyILKSYDWaNJX6k68aYpVR4)
-  [02 - Not in Kansas Anymore - Symbols  ](https://docs.google.com/document/d/1eiaFmKfTTUxjhphgcOM9-5eioenaFR91rw4ME9jCL30)
-  [03 - Evolution             - Packages and Systems](https://docs.google.com/document/d/1Yv8PtBJDwg4fqZtIYNmYDw_8N3KwlCzcO_urI9-NwIk)
-  [04 - Inconceivable         - Functions](https://docs.google.com/document/d/1j5sqsXFUj8pyZhttAywQnAyqz9t1RGGlVGqp9qKJDt0)
-  [05 - Lisp Loves Donuts     - Control  ](https://docs.google.com/document/d/1rm6-s63PMzgyFX2BYLmX_nNqJ-uFiHxOuFm7ITqQPDI)
-  [06 - Wax on, Wax Off       - Globals and Lists](https://docs.google.com/document/d/1PBES_SbntPf5mtdtc2_EZvdJf1SAnJ0JrHYfbL7sbE8)
-  [07 - Spin Me Right 'Round  - Closures, Loops and Strings](https://docs.google.com/document/d/1qK397lNNmKL5x_1usrwsZEIcZVBdYmAREajSDc7Dpu0)
-  [08 - Only A Mom Could Love - Format and Loop](https://docs.google.com/document/d/1L9jdKE-XrCU0VhdsmO5w9-2ozNDrrW1-JOAi3kHrlu4)
-  [09 - I Want a New Drug     - Hash and Arrays](https://docs.google.com/document/d/1H-wx50sr0Oseh3qAGrO8LbEfHS-KnbVSrNBWOAJhStI)
-  [10 - Following             - Mapping functions](https://docs.google.com/document/d/1NThII3vh4d6UC_eVvBtMHYvSTKN3ARk_iOxJY4oIRdk)
-  [11 - Build Me Up           - Structs and CLOS](https://docs.google.com/document/d/1CmaDW1h9P5_bjWRqWK-LBf8GSIrCbXUcXIpEKJnF6Wg)
-  [12 - Expand Your Mind      - Macros   ](https://docs.google.com/document/d/1Hnko12U6LI2o1cH9TgByN6D-lpdOzUmaVUJWxooMFow)
-  [13 - Y'all come back now   - Exceptions/Conditions](https://docs.google.com/document/d/1bwTipjdEqkNRZVYjwrBGWKqLD1IXeWGofQqgXGdZJ48)
-  [14 - Kindergarten          - Concurrent and Parallel Programing](https://docs.google.com/document/d/10MGPC7j4lpGrMlQS4xtQTEGrvpBecgDUnqu1OrjSVxk)
-  [15 - Pulling it All Togeher With A Real GUI App - clos-encounters game](https://github.com/rabbibotton/clos-encounters)

Other Tutorials and General Material:
- [lisp-lang](https://lisp-lang.org/)
- [Awesome-CL libraries](https://github.com/CodyReichert/awesome-cl)

Other Quick Resources:
- [Lisp Cheat Sheet](https://github.com/ashok-khanna/lisp-notes)
- [Lisp in Y Minutes](https://learnxinyminutes.com/docs/common-lisp/)
- [Common Lisp Cookbook](https://lispcookbook.github.io/cl-cookbook/)

Full Free Books:
- Reference - [Common Lisp the Language 2nd ed](http://www.cs.cmu.edu/Groups/AI/html/cltl/cltl2.html)
- New to Programming - [Common Lisp: A Gentle Introduction to Symbolic Computing](http://www.cs.cmu.edu/%7Edst/LispBook/)
- New to Common Lisp - [Practical Common Lisp](http://www.gigamonkeys.com/book/)

![Image of CLOG](https://rabbibotton.github.io/images/demo-clog-contact.png)

CLOG Builder Tutorials (Reddit links)

-  [01 - Chat App                        ](https://www.reddit.com/r/lisp/comments/sj1tv5/clog_builder_tutorial_1_a_chat_app_from_start_to/)
-  [02 - Building a Web Page             ](https://www.reddit.com/r/lisp/comments/sn8j77/clog_builder_tutorial_2_building_a_web_page/)
-  [03 - Importing HTML in to Builder    ](https://www.reddit.com/r/lisp/comments/snvv0w/clog_builder_tutorial_3_importing_html_adding/)
-  [04 - CLOS-CONTACT - database controls, a complete application](https://www.reddit.com/r/lisp/comments/t61sib/clog_builder_tutorial_4_a_complete_database_app/)
    -  (Completed Tutorial 4 at https://github.com/rabbibotton/clos-contact but you better do the tutorial!)
-  [05 - Using and Creating Controls     ](https://www.reddit.com/r/lisp/comments/w2d6dr/builder_tutorial_5_using_and_creating_lisp_custom/)

CLOG "The Framework" (Code Tutorials)

- [01-tutorial.lisp](tutorial/01-tutorial.lisp) - Hello World
- [02-tutorial.lisp](tutorial/02-tutorial.lisp) - Closures in CLOG
- [03-tutorial.lisp](tutorial/03-tutorial.lisp) - Events fire in parallel
- [04-tutorial.lisp](tutorial/04-tutorial.lisp) - The event target, reusing event handlers
- [05-tutorial.lisp](tutorial/05-tutorial.lisp) - Using connection-data-item
- [06-tutorial.lisp](tutorial/06-tutorial.lisp) - Tasking and events
- [07-tutorial.lisp](tutorial/07-tutorial.lisp) - My first CLOG video game (and handling disconnects)
- [08-tutorial.lisp](tutorial/08-tutorial.lisp) - Mice Love Containers
- [09-tutorial.lisp](tutorial/09-tutorial.lisp) - Tabs, panels, and forms
- [10-tutorial.lisp](tutorial/10-tutorial.lisp) - Canvas
- [11-tutorial.lisp](tutorial/11-tutorial.lisp) - Attaching to existing HTML
- [12-tutorial.lisp](tutorial/12-tutorial.lisp) - Running a website in CLOG (routing)
- [13-tutorial/](tutorial/13-tutorial) - Flying Solo - A minimalist CLOG project
- [14-tutorial.lisp](tutorial/14-tutorial.lisp) - Local (persistent) and Session client-side storage
- [15-tutorial.lisp](tutorial/15-tutorial.lisp) - Multi-media
- [16-tutorial.lisp](tutorial/16-tutorial.lisp) - Bootstrap 4, Loading css files and javascript
- [17-tutorial.lisp](tutorial/17-tutorial.lisp) - W3.CSS layout example and Form submit methods
- [18-tutorial.lisp](tutorial/18-tutorial.lisp) - Drag and Drop
- [19-tutorial.lisp](tutorial/19-tutorial.lisp) - Using JavaScript components
- [20-tutorial.lisp](tutorial/20-tutorial.lisp) - New CLOG plugin from JavaScript component
- [21-tutorial.lisp](tutorial/21-tutorial.lisp) - New CLOG plugin in Common-Lisp
- [22-tutorial.lisp](tutorial/22-tutorial.lisp) - CLOG GUI Menus and Desktop Look and Feel
- [23-tutorial.lisp](tutorial/23-tutorial.lisp) - Using semaphores to wait for input
- [24-tutorial.lisp](tutorial/24-tutorial.lisp) - CLOG WEB containers
- [25-tutorial.lisp](tutorial/25-tutorial.lisp) - A "local" web app using CLOG WEB
- [26-tutorial.lisp](tutorial/26-tutorial.lisp) - A web page and form with CLOG WEB
- [27-tutorial.lisp](tutorial/27-tutorial.lisp) - Panel Box Layouts
- [28-tutorial/](tutorial/28-tutorial) - CLOG Builder Hello - A minimalist CLOG Builder project
- [29-tutorial.lisp](tutorial/29-tutorial.lisp) - Presentations (and jQuery) - linking lisp objects to clog objects
- [30-tutorial.lisp](tutorial/30-tutorial.lisp) - Instant websites - clog-web-site
- [31-tutorial.lisp](tutorial/31-tutorial.lisp) - Database and Authority based websites - clog-web-dbi and clog-auth
- [32-tutorial.lisp](tutorial/32-tutorial.lisp) - Database Managed Content websites - clog-web-content
- [33-tutorial.lisp](tutorial/33-tutorial.lisp) - with-clog-create - Using a declarative syntax for GUIs

CLOG Demos - Learn through Projects

- [01-demo.lisp](demos/01-demo.lisp) - Sparkey the Snake Game
- [02-demo.lisp](demos/02-demo.lisp) - Chat - Private instant messenger
- [03-demo.lisp](demos/03-demo.lisp) - IDE - A very simple common lisp IDE
  (see source if editor dosen't load)
- [04-demo.lisp](demos/04-demo.lisp) - CMS Website - A very simple database driven website
- [clos-encounters](https://github.com/rabbibotton/clos-encounters) - Full Project - Game
- [clos-contact](https://github.com/rabbibotton/clos-contact) - Full Project - Business App

Misc CLOG Tutorials

- [Wrapping a JS Plugin](https://docs.google.com/document/d/1EDODcnyijP_EjrDQTiA0AB-zbMQzvCo2HltXarw5q5A)

MANUAL

https://rabbibotton.github.io/clog/clog-manual.html


GENERAL INFORMATION

[CLOG - Technical Overview and Purpose](CONCEPT.md)
